Tree Canopy in JavaScript

Using ApexCharts with JavaScript

This Tree Canopy example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [28800, 8400, 2100, 1700],
  chart: {
    type: 'unit',
    height: 470,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: ['Oak', 'Silver birch', 'Rowan', 'Wild cherry'],
  // Green where the canopy is dense, then earth tones for the smaller species:
  // four greens would be a single unreadable mass at this dot size, while green
  // plus ochre plus bark keeps the tree looking like a tree.
  colors: ['#2E7D32', '#7CB342', '#C9A227', '#8D6E63'],
  plotOptions: {
    unit: {
      layout: 'custom',
      // One of the shapes in apexcharts/unit-shapes.
      positions: 'tree',
      transition: 'flow',
      unitValue: 50,
      clusterLabels: {
        external: {
          show: true,
        },
      },
    },
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Tree Canopy in Angular

Using ApexCharts with Angular

This Tree Canopy example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [28800, 8400, 2100, 1700],
          chart: {
            type: 'unit',
            height: 470,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: ['Oak', 'Silver birch', 'Rowan', 'Wild cherry'],
          // Green where the canopy is dense, then earth tones for the smaller species:
          // four greens would be a single unreadable mass at this dot size, while green
          // plus ochre plus bark keeps the tree looking like a tree.
          colors: ['#2E7D32', '#7CB342', '#C9A227', '#8D6E63'],
          plotOptions: {
            unit: {
              layout: 'custom',
              // One of the shapes in apexcharts/unit-shapes.
              positions: 'tree',
              transition: 'flow',
              unitValue: 50,
              clusterLabels: {
                external: {
                  show: true,
                },
              },
            },
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Tree Canopy in Vue

Using ApexCharts with Vue

This Tree Canopy example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>41,000 saplings, one dot per 50</h1>
      <p>
        A lobed canopy over a flared trunk, packed with dots. The outline is two
        overlapping subpaths, which the layout unions before it packs, so a
        canopy with nine bumps and a trunk with roots is one shape rather than a
        circle balanced on a rectangle.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="470"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <p class="note">1 dot = 50 saplings planted this season</p>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [28800, 8400, 2100, 1700],
      chartOptions: {
        chart: {
          type: 'unit',
          height: 470,
          animations: {
            enabled: true,
            speed: 900,
          },
        },
        labels: ['Oak', 'Silver birch', 'Rowan', 'Wild cherry'],
        // Green where the canopy is dense, then earth tones for the smaller species:
        // four greens would be a single unreadable mass at this dot size, while green
        // plus ochre plus bark keeps the tree looking like a tree.
        colors: ['#2E7D32', '#7CB342', '#C9A227', '#8D6E63'],
        plotOptions: {
          unit: {
            layout: 'custom',
            // One of the shapes in apexcharts/unit-shapes.
            positions: 'tree',
            transition: 'flow',
            unitValue: 50,
            clusterLabels: {
              external: {
                show: true,
              },
            },
          },
        },
        legend: {
          show: false,
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin: 16px 0 0;
}
</style>

Tree Canopy in React

Using ApexCharts with React

This Tree Canopy example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [28800, 8400, 2100, 1700],
    options: {
      chart: {
        type: 'unit',
        height: 470,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: ['Oak', 'Silver birch', 'Rowan', 'Wild cherry'],
      // Green where the canopy is dense, then earth tones for the smaller species:
      // four greens would be a single unreadable mass at this dot size, while green
      // plus ochre plus bark keeps the tree looking like a tree.
      colors: ['#2E7D32', '#7CB342', '#C9A227', '#8D6E63'],
      plotOptions: {
        unit: {
          layout: 'custom',
          // One of the shapes in apexcharts/unit-shapes.
          positions: 'tree',
          transition: 'flow',
          unitValue: 50,
          clusterLabels: {
            external: {
              show: true,
            },
          },
        },
      },
      legend: {
        show: false,
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>41,000 saplings, one dot per 50</h1>
        <p>
          A lobed canopy over a flared trunk, packed with dots. The outline is
          two overlapping subpaths, which the layout unions before it packs, so
          a canopy with nine bumps and a trunk with roots is one shape rather
          than a circle balanced on a rectangle.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={470}
            />
          </div>
        </div>

        <p className="note">1 dot = 50 saplings planted this season</p>
      </div>
    </div>
  )
}

export default ApexChart